#!/system/bin/sh

cat << CTAG
{
    name:{en:"Int Storage", ko:"내부 저장소"},
    elements:[

	{ SPane:{
		title:"General I/O Tunables",
		description:" Set the internal storage general tunables"
	}},
	{ SSpacer:{ height:1 }},

	{ SCheckBox:{
		description:" Maintain I/O statistics for this storage device. Disabling will break I/O monitoring apps. Default is Enabled.",
		label:"I/O Stats",
		default:`cat /sys/block/mmcblk0/queue/iostats`,
		action:"ioset queue iostats"
	}},
	{ SSpacer:{ height:1 }},

	{ SCheckBox:{
		description:" Treat device as rotational storage. Default is Disabled",
		label:"Rotational",
		default:`cat /sys/block/mmcblk0/queue/rotational`,
		action:"ioset queue rotational"
	}},
	{ SSpacer:{ height:1 }},

    { SOptionList:{
        title:"No Merges",
        description:"Types of merges (prioritization) the scheduler queue for this storage device allows.",
        default:`cat /sys/block/mmcblk0/queue/nomerges`,
        action:"generic /sys/block/mmcblk0/queue/nomerges",
        values:{
            0:"All", 1:"Simple Only", 2:"None"
        }
    }},
    { SOptionList:{
        title:"RQ Affinity",
        description:"Try to have scheduler requests complete on the CPU core they were made from. Higher is more aggressive.",
        default:`cat /sys/block/mmcblk0/queue/rq_affinity`,
        action:"generic /sys/block/mmcblk0/queue/rq_affinity",
        values:{
            0:"Disabled", 1:"Enabled", 2:"Aggressive"
        }
    }},
	{ SSpacer:{ height:1 }},


    { SPane:{
		title:{en:"I/O schedulers", ko:"I/O 스케줄러"},
		description:{en:"Set the active I/O elevator algorithm. The scheduler decides how to handle I/O requests and how to handle them.", ko:" 스케줄러는 I/O 요청을 처리하는 알고리즘을 결정하며 각각 다른 특성을 가집니다.\n* 미리읽기 값이 크다고 해서 반드시 더 빠른 것은 아닙니다."}
    }},
	{ SOptionList:{
		title:{en:"Internal storage scheduler", ko:"내부 저장소 스케줄러"},
		default:`cat /sys/block/mmcblk0/queue/scheduler | /res/bin/busybox awk 'NR>1{print $1}' RS=[ FS=]`,
		action:"scheduler /sys/block/mmcblk0/queue/scheduler",
		values:[`
			while read values; do
				/res/bin/busybox printf "%s, \n" $values | /res/bin/busybox tr -d '[]';
			done < /sys/block/mmcblk0/queue/scheduler`
		],
		notify:[
			{
				on:APPLY,
				do:[ REFRESH, CANCEL ],
				to:"/sys/block/mmcblk0/queue/iosched"
			},
			{
				on:REFRESH,
				do:REFRESH,
				to:"/sys/block/mmcblk0/queue/iosched"
			}
		]
	}},
	{ SSeekBar:{
		title:{en:"Internal storage read-ahead", ko:"내부 저장소 미리읽기 크기"},
		max:4096,
		min:128,
		unit:" kB",
		step:128,
		default:`cat /sys/block/mmcblk0/queue/read_ahead_kb`,
		action:"generic /sys/block/mmcblk0/queue/read_ahead_kb"
	}},
	{ SSpacer:{ height:1 }},

	{ STitleBar:{
		title:"I/O Scheduler Tunables"
	}},
	{ SSpacer:{ height:1 }},
	{ STreeDescriptor:{
		path:"/sys/block/mmcblk0/queue/iosched",
		generic: {
			directory: {},
			element: {
				SGeneric: { title:"@BASENAME" }
			}
		},
		exclude: [ "weights", "wr_max_time" ]
	}},
	{ SSpacer:{ height:1 }},
    ]
},
CTAG
